<!--
  ~ (c) Copyright 2024 Swiss Post Ltd.
  -->
<div *ngIf="!generationInProgress">
  <b>Generate the keystore for:</b>
  <br>
  <form [formGroup]="generationForm">
    <ng-container formGroupName="components">
      <div *ngFor="let component of availableComponents" class="form-group form-check form-check">
        <input [value]="component" class="form-check-input" formControlName="{{component.key}}" id="{{component.key}}"
               type="checkbox">
        <label class="form-check-label" for="{{component.key}}">{{ component.label }}</label>
      </div>
    </ng-container>
    <hr>
    <b>Certificate parameters</b>
    <br>
    <label class="form-check-label" for="validUntil">Valid until</label>
    <input class="form-control form-control-monospace me-sm-3" formControlName="validUntil" id="validUntil" type="date">
    <label class="form-check-label" for="country">Country</label>
    <input class="form-control form-control-monospace me-sm-3" formControlName="country" id="country" type="text">
    <label class="form-check-label" for="state">State</label>
    <select class="form-select me-sm-3" formControlName="state" id="state">
        <option *ngFor="let state of availableStates" class="form-group dropdown">{{state}}</option>
    </select>
    <label class="form-check-label" for="locality">Locality</label>
    <input class="form-control form-control-monospace me-sm-3" formControlName="locality" id="locality" type="text">
    <label class="form-check-label" for="organisation">Name of Direct Trust ceremony</label>
    <input aria-describedby="organisationInstruction" class="form-control form-control-monospace me-sm-3" formControlName="organisation" id="organisation" type="text">
    <p class="mb-3" id="organisationInstruction">
      The name of the Direct Trust ceremony should match the following format: DT_CT_YYYYMMDD_XY01
    </p>
    <ul
      aria-labelledby="organisationInstruction"
      class="list-unstyled ms-3 d-flex flex-column gap-2"
    >
      <li *ngFor="let policy of organisationPolicies">
        <i
          [ngClass]="!hasError(policy) ? 'bi-check2-circle' : 'bi-circle'"
          aria-hidden="true"
          class="bi me-2 text-primary"
          data-test="indicator"
        ></i>
        <span aria-hidden="true" data-test="label">{{ organisationPoliciesText.get(policy) }}</span>
      </li>
    </ul>

    <label class="form-check-label" for="platform">Enter the name of the platform (e.g. 'prod')</label>
    <input class="form-control form-control-monospace me-sm-3" formControlName="platform" id="platform" type="text">
    <ul class="font-weight-light">
      <li>This field may be left empty.</li>
      <li>It must contain only letters.</li>
      <li>All the downloaded files will be tagged with it.</li>
    </ul>

    <button (click)="generateKeystores()" [disabled]="generationForm.invalid" class="btn btn-dark mt-3" type="submit">Select</button>
  </form>
</div>
<div *ngIf="generationInProgress" class="pt-4">
  <p>Generation in progress please wait...</p>
  <div class="spinner-border" role="status"></div>
</div>
